"""Autogenerated API schema"""
from argus_api import session


add_host_asset = {'tags': ['assets/v1'], 'summary': 'Creates a new HostAsset. (PUBLIC)', 'description': '', 'operationId': 'addHostAsset', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'HostAsset add request', 'required': False, 'schema': {'type': 'object', 'required': ['customerID', 'name', 'source', 'type'], 'properties': {'ownerID': {'type': 'int', 'position': 0, 'description': 'User who owns the asset. '}, 'customerID': {'type': 'int', 'position': 0, 'description': 'Customer the asset belongs to. ', 'minimum': 1}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of the asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'type': {'type': 'str', 'position': 0, 'description': 'Defines if host is a client or a server. (default SERVER)', 'enum': ['SERVER', 'CLIENT']}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'operatingSystemCPE': {'type': 'str', 'position': 0, 'description': 'CPE of the host operating system. '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'IP address(es) of the host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Aliases (domain names) of the host. ', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
bulk_update_host_asset = {'tags': ['assets/v1'], 'summary': 'Performs multiple updates to HostAssets in a single transaction. (PUBLIC)', 'description': '', 'operationId': 'bulkUpdateHostAsset', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'HostAsset bulk update request', 'required': False, 'schema': {'type': 'object', 'required': ['source'], 'properties': {'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'assetVulnerabilityAddRequests': {'type': 'list', 'position': 0, 'description': 'List of AssetVulnerabilityAddRequests. ', 'items': {'type': 'dict', 'required': ['hostID', 'vulnerabilityID'], 'properties': {'hostID': {'type': 'str', 'position': 0, 'description': 'Specify parent host. '}, 'vulnerabilityID': {'type': 'str', 'position': 0, 'description': 'Identifier of vulnerability (e.g. plug-in ID from vulnerability scanner).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'references': {'type': 'list', 'position': 0, 'description': 'References to vulnerability (e.g. CVE number). ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of vulnerability. Will be sanitized and no line break allowed. ', 'minLength': 0, 'maxLength': 255}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of vulnerability. Will be sanitized. '}, 'conclusion': {'type': 'str', 'position': 0, 'description': 'Short summary of vulnerability. Will be sanitized. '}, 'solution': {'type': 'str', 'position': 0, 'description': 'How to fix vulnerability. Will be sanitized. '}, 'rawOutput': {'type': 'str', 'position': 0, 'description': 'Raw output from vulnerability scan. Will be sanitized. '}, 'cvss': {'type': 'float', 'position': 0, 'description': 'CVSS score of vulnerability (range from 0 to 10). ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'str', 'position': 0, 'description': 'Severity level of vulnerability. ', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'exploitAvailable': {'type': 'bool', 'position': 0, 'description': 'Set if an exploit is available for the vulnerability. '}, 'socket': {'type': 'str', 'position': 0, 'description': 'Specify socket string of the vulnerability (e.g. tcp/80), or omit if not bound to a socket. '}}}}, 'assetVulnerabilityUpdateRequests': {'type': 'list', 'position': 0, 'description': 'List of AssetVulnerabilityUpdateRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'addReferences': {'type': 'list', 'position': 0, 'description': 'Add references to vulnerability (e.g. CVE number). ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteReferences': {'type': 'list', 'position': 0, 'description': 'Delete references from vulnerability. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'str', 'position': 0, 'description': 'Change vulnerability name. Will be sanitized and no line break allowed. ', 'minLength': 0, 'maxLength': 255}, 'description': {'type': 'str', 'position': 0, 'description': 'Change vulnerability description. Will be sanitized. '}, 'conclusion': {'type': 'str', 'position': 0, 'description': 'Change vulnerability summary. Will be sanitized. '}, 'solution': {'type': 'str', 'position': 0, 'description': 'Change vulnerability solution. Will be sanitized. '}, 'rawOutput': {'type': 'str', 'position': 0, 'description': 'Change raw output from vulnerability scan. Will be sanitized. '}, 'cvss': {'type': 'float', 'position': 0, 'description': 'Change CVSS score of vulnerability (range from 0 to 10). ', 'minimum': 0, 'maximum': 10}, 'severity': {'type': 'str', 'position': 0, 'description': 'Change severity level of vulnerability. ', 'enum': ['INFO', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'info', 'low', 'medium', 'high', 'critical']}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add custom properties (updates a property if key already exists).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Delete custom properties by key. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'exploitAvailable': {'type': 'bool', 'position': 0, 'description': 'Set if an exploit is available for the vulnerability. '}, 'id': {'type': 'str', 'position': 0, 'description': 'ID of vulnerability to update '}}}}, 'assetVulnerabilityResolveRequests': {'type': 'list', 'position': 0, 'description': 'List of AssetVulnerabilityResolveRequests. ', 'items': {'type': 'dict', 'required': ['comment', 'id', 'resolution'], 'properties': {'resolution': {'type': 'str', 'position': 0, 'description': 'Specify resolution reason. ', 'enum': ['ACCEPTED', 'TEMPORARILY_ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE']}, 'resolutionExpiryTimestamp': {'type': 'int', 'position': 0, 'description': 'When will the current resolution expire (0 means no expiry). Allows unix timestamp (milliseconds), ISO timestamp, or relative time values. See https://docs.mnemonic.no/x/AQDXAQ (default 0)', 'minimum': 0, 'default': 0}, 'comment': {'type': 'str', 'position': 0, 'description': 'Comment on why the vulnerability is resolved.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'id': {'type': 'str', 'position': 0, 'description': 'ID of vulnerability to resolve '}}}}, 'assetVulnerabilityDeleteRequests': {'type': 'list', 'position': 0, 'description': 'List of AssetVulnerabilityDeleteRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'id': {'type': 'str', 'position': 0, 'description': 'ID of vulnerability to delete '}}}}, 'hostApplicationAddRequests': {'type': 'list', 'position': 0, 'description': 'List of HostApplicationAddRequests. ', 'items': {'type': 'dict', 'required': ['hostID', 'sockets'], 'properties': {'hostID': {'type': 'str', 'position': 0, 'description': 'Specify parent host. '}, 'roleID': {'type': 'int', 'position': 0, 'description': 'Specify application role. '}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of application.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of application.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'cpe': {'type': 'str', 'position': 0, 'description': 'CPE of application. '}, 'sockets': {'type': 'list', 'position': 0, 'description': 'Specify socket strings of the application. ', 'uniqueItems': True, 'items': {'type': 'string'}}}}}, 'hostApplicationUpdateRequests': {'type': 'list', 'position': 0, 'description': 'List of HostApplicationUpdateRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'roleID': {'type': 'int', 'position': 0, 'description': 'Change application role. '}, 'name': {'type': 'str', 'position': 0, 'description': 'Change application name.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Change application description.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add properties to application (updates a property if key already exists).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Remove properties from application by key. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'id': {'type': 'str', 'position': 0, 'description': 'ID of application to update '}, 'cpe': {'type': 'str', 'position': 0, 'description': 'Change application CPE. '}, 'addSockets': {'type': 'list', 'position': 0, 'description': 'Add sockets to application (list of protocol/port, e.g. tcp/80). ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteSockets': {'type': 'list', 'position': 0, 'description': 'Remove sockets from application (list of protocol/port, e.g. tcp/80). ', 'uniqueItems': True, 'items': {'type': 'string'}}}}}, 'hostApplicationDeleteRequests': {'type': 'list', 'position': 0, 'description': 'List of HostApplicationDeleteRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'id': {'type': 'str', 'position': 0, 'description': 'ID of application to delete '}}}}, 'hostAssetAddRequests': {'type': 'list', 'position': 0, 'description': 'List of HostAssetAddRequests. Adding vulnerabilities/applications to added hosts must be done in separate transaction. ', 'items': {'type': 'dict', 'required': ['customerID', 'name', 'type'], 'properties': {'ownerID': {'type': 'int', 'position': 0, 'description': 'User who owns the asset. '}, 'customerID': {'type': 'int', 'position': 0, 'description': 'Customer the asset belongs to. ', 'minimum': 1}, 'name': {'type': 'str', 'position': 0, 'description': 'Name of the asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Description of the asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Custom user-defined properties.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'operatingSystemCPE': {'type': 'str', 'position': 0, 'description': 'CPE of the host operating system. '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'IP address(es) of the host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Aliases (domain names) of the host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'options': ['SERVER', 'CLIENT']}}}, 'hostAssetUpdateRequests': {'type': 'list', 'position': 0, 'description': 'List of HostAssetUpdateRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'ownerID': {'type': 'int', 'position': 0, 'description': 'Change user who owns the asset. '}, 'name': {'type': 'str', 'position': 0, 'description': 'Change name of asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Change description of asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}}}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add custom properties (updates a property if key already exists).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Delete custom properties by key. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'type': 'str', 'id': {'type': 'str', 'position': 0, 'description': 'ID of host to update '}, 'operatingSystemCPE': {'type': 'str', 'position': 0, 'description': 'Change CPE of host. '}, 'addIpAddresses': {'type': 'list', 'position': 0, 'description': 'Add IP address(es) to host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteIpAddresses': {'type': 'list', 'position': 0, 'description': 'Delete IP address(es) from host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'addAliases': {'type': 'list', 'position': 0, 'description': 'Add alias(es) (domain names) to host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteAliases': {'type': 'list', 'position': 0, 'description': 'Delete alias(es) from host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'options': ['SERVER', 'CLIENT']}}}, 'hostAssetDeleteRequests': {'type': 'list', 'position': 0, 'description': 'List of HostAssetDeleteRequests. ', 'items': {'type': 'dict', 'required': ['id'], 'properties': {'id': {'type': 'str', 'position': 0, 'description': 'ID of host to delete '}}}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'updatedHosts': {'type': 'list', 'position': 0, 'description': 'All hosts affected by update (including add/update/delete of vulnerabilities and applications) ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}, 'addedHosts': {'type': 'list', 'position': 0, 'description': 'List of added hosts (same order as add requests) ', 'items': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
delete_host_asset = {'tags': ['assets/v1'], 'summary': 'Marks a HostAsset as deleted. (PUBLIC)', 'description': '', 'operationId': 'deleteHostAsset', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostAsset ID', 'required': True, 'type': 'str'}, {'name': 'source', 'in': 'query', 'description': 'Request source (default USER)', 'required': False, 'type': 'str', 'default': 'USER', 'enum': ['USER', 'CVM']}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
get_host_asset = {'tags': ['assets/v1'], 'summary': 'Returns a HostAsset identified by its ID. (PUBLIC)', 'description': '', 'operationId': 'getHostAsset', 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostAsset ID', 'required': True, 'type': 'str'}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
merge_host_asset = {'tags': ['assets/v1'], 'summary': 'Merges multiple HostAssets into one. (INTERNAL)', 'description': "This operation takes multiple HostAssets (merge from) and merges them into another existing HostAsset (merge into). Thereby collection fields from all HostAssets are combined by calculating their union. Conflicts between single value fields can be resolved manually by explicitly specifying the values to use in the request. By default the values from the merge into HostAsset will be retained. When 'mergeApplications' or 'mergeVulnerabilities' are set in the request applications and vulnerabilities are merged as well, i.e. all applications and vulnerabilities from all HostAssets will be present in the merge result. But duplicated applications and vulnerabilities will be omitted.", 'operationId': 'mergeHostAsset', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'mergeIntoID', 'in': 'path', 'description': 'ID of HostAsset to merge into. This HostAsset is kept and contains the merge result.', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'Request specifying HostAssets to merge from and fields to overwrite in merge result.', 'required': False, 'schema': {'type': 'object', 'required': ['mergeFromID'], 'properties': {'mergeFromID': {'type': 'list', 'position': 0, 'description': 'Merge from hosts identified by their IDs. ', 'uniqueItems': True, 'items': {'type': 'str'}, 'maxItems': 2147483647, 'minItems': 1}, 'ownerID': {'type': 'int', 'position': 0, 'description': 'Set owner of merged host. Keeps owner of merge into host if not provided. ', 'minimum': 1}, 'name': {'type': 'str', 'position': 0, 'description': 'Set name of merged host. Keeps name of merge into host if not provided.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Set description of merged host. Keeps description of merge into host if not provided.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}}}, 'type': {'type': 'str', 'position': 0, 'description': 'Set type of merged host. Keeps type of merge into host if not provided. ', 'enum': ['SERVER', 'CLIENT']}, 'mergeApplications': {'type': 'bool', 'position': 0, 'description': 'If set to true also merge applications (defaults to false). '}, 'mergeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'If set to true also merge vulnerabilities (defaults to false). '}, 'operatingSystemCPE': {'type': 'str', 'position': 0, 'description': 'Set operating system CPE of merged host. Keeps CPE of merge into host if not provided. '}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}
search_host_asset_statistics = {'tags': ['assets/v1'], 'summary': 'Fetch host asset statistics base on criteria (PUBLIC)', 'description': '', 'operationId': 'searchHostAssetStatistics', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Statistics search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'ownerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific ownerIDs ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'criticality': {'type': 'list', 'position': 0, 'description': 'Restrict search to a range of criticality levels (add multiple CriticalitySearch objects to specify OR criteria). ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['dimension', 'severities'], 'properties': {'dimension': {'type': 'str', 'position': 0, 'description': 'Which criticality dimention to search for ', 'enum': ['CONFIDENTIALITY', 'AVAILABILITY', 'INTEGRITY']}, 'severities': {'type': 'list', 'position': 0, 'description': 'Which severities to filter for specified dimension ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'maxItems': 2147483647, 'minItems': 1}}}}, 'minimumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a minimum total CVSS score. '}, 'maximumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a maximum total CVSS score. '}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Restrict to applications with specific roles (list of role IDs). ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'type': 'str', 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp on host). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}}, 'includeVulnerabilityRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false). '}, 'includeVulnerabilityConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false). '}, 'includeVulnerabilitySolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false). '}, 'includeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'Include host vulnerabilities in result (default false). '}, 'includeApplications': {'type': 'bool', 'position': 0, 'description': 'Include host applications in result (default false). '}, 'includeServices': {'type': 'bool', 'position': 0, 'description': 'Include related services in result (default false). '}, 'connectedToService': {'type': 'bool', 'position': 0, 'description': 'If true, only return hosts connected to service(s). If false, return hosts not connected to any service. If not set, do not filter. '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['owner', 'customer', 'name', 'totalCvss', 'vulnerabilitiesCount', 'operatingSystemCPE', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'options': ['SERVER', 'CLIENT']}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'ownerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific ownerIDs ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'criticality': {'type': 'list', 'position': 0, 'description': 'Restrict search to a range of criticality levels (add multiple CriticalitySearch objects to specify OR criteria). ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['dimension', 'severities'], 'properties': {'dimension': {'type': 'str', 'position': 0, 'description': 'Which criticality dimention to search for ', 'enum': ['CONFIDENTIALITY', 'AVAILABILITY', 'INTEGRITY']}, 'severities': {'type': 'list', 'position': 0, 'description': 'Which severities to filter for specified dimension ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'maxItems': 2147483647, 'minItems': 1}}}}, 'minimumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a minimum total CVSS score. '}, 'maximumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a maximum total CVSS score. '}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Restrict to applications with specific roles (list of role IDs). ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'type': 'str', 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp on host). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}}, 'includeVulnerabilityRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false). '}, 'includeVulnerabilityConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false). '}, 'includeVulnerabilitySolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false). '}, 'includeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'Include host vulnerabilities in result (default false). '}, 'includeApplications': {'type': 'bool', 'position': 0, 'description': 'Include host applications in result (default false). '}, 'includeServices': {'type': 'bool', 'position': 0, 'description': 'Include related services in result (default false). '}, 'connectedToService': {'type': 'bool', 'position': 0, 'description': 'If true, only return hosts connected to service(s). If false, return hosts not connected to any service. If not set, do not filter. '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['owner', 'customer', 'name', 'totalCvss', 'vulnerabilitiesCount', 'operatingSystemCPE', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'options': ['SERVER', 'CLIENT']}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'ownerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific ownerIDs ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'criticality': {'type': 'list', 'position': 0, 'description': 'Restrict search to a range of criticality levels (add multiple CriticalitySearch objects to specify OR criteria). ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['dimension', 'severities'], 'properties': {'dimension': {'type': 'str', 'position': 0, 'description': 'Which criticality dimention to search for ', 'enum': ['CONFIDENTIALITY', 'AVAILABILITY', 'INTEGRITY']}, 'severities': {'type': 'list', 'position': 0, 'description': 'Which severities to filter for specified dimension ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'maxItems': 2147483647, 'minItems': 1}}}}, 'minimumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a minimum total CVSS score. '}, 'maximumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a maximum total CVSS score. '}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Restrict to applications with specific roles (list of role IDs). ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'type': {'type': 'str', 'position': 0, 'description': 'Restrict search to a specific type of host (client or server). ', 'enum': ['SERVER', 'CLIENT']}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp on host). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}}, 'includeVulnerabilityRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false). '}, 'includeVulnerabilityConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false). '}, 'includeVulnerabilitySolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false). '}, 'includeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'Include host vulnerabilities in result (default false). '}, 'includeApplications': {'type': 'bool', 'position': 0, 'description': 'Include host applications in result (default false). '}, 'includeServices': {'type': 'bool', 'position': 0, 'description': 'Include related services in result (default false). '}, 'connectedToService': {'type': 'bool', 'position': 0, 'description': 'If true, only return hosts connected to service(s). If false, return hosts not connected to any service. If not set, do not filter. '}, 'groupBy': {'type': 'list', 'position': 0, 'description': 'Specify which fields will be grouped by in stats ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['customer', 'service', 'integrity', 'confidentiality', 'availability', 'operatingSystemVendor', 'operatingSystemName', 'operatingSystemVersion']}}, 'values': {'type': 'list', 'position': 0, 'description': 'Specify which values will be included in stats (default hosts) ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['hosts', 'scannedHosts', 'totalCvss']}, 'maxItems': 2147483647, 'minItems': 1}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Stats resolution period in milliseconds, if is 0 means to generate non-timeline statistics ', 'minimum': 0}, 'cutoff': {'type': 'int', 'position': 0, 'description': 'Reduce stats keys to the cutoff amount of keys that has largest hit count, default 0 means no reduce ', 'minimum': 0}, 'cutoffValue': {'type': 'str', 'position': 0, 'description': 'Specify which value to be cutoff on (default hosts) ', 'enum': ['hosts', 'scannedHosts', 'totalCvss']}, 'includeOthers': {'type': 'bool', 'position': 0, 'description': 'If reduce (cutoff>0), true means remaining keys (other than cutoff keys) are collected into an "other" key, default false '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['owner', 'customer', 'name', 'totalCvss', 'vulnerabilitiesCount', 'operatingSystemCPE', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'properties': {'statsID': {'type': 'int', 'position': 0, 'description': 'Statistics ID '}, 'customerID': {'type': 'int', 'position': 0, 'description': 'Customer ID '}, 'resolution': {'type': 'int', 'position': 0, 'description': 'Statistics time frame period length '}, 'resolutionUnit': {'type': 'str', 'position': 0, 'description': 'Time unit for the resolution ', 'enum': ['milliseconds', 'seconds', 'minutes', 'hours', 'days', 'weeks', 'months', 'years']}, 'records': {'type': 'int', 'position': 0, 'description': 'Amount of records '}, 'hitCount': {'type': 'dict', 'position': 0, 'description': 'Total amount of hits per value ', 'additionalProperties': {'type': 'int'}}, 'keyNames': {'type': 'list', 'position': 0, 'description': 'List of key names ', 'items': {'type': 'string'}}, 'valueNames': {'type': 'list', 'position': 0, 'description': 'List of value names ', 'items': {'type': 'string'}}, 'keys': {'type': 'list', 'position': 0, 'description': 'List of statistics keys e.g. {"id":1, "key1Name":"key1", "key2Name":"key2"} ', 'items': {'type': 'dict', 'additionalProperties': {'type': 'object'}}}, 'timeFrames': {'type': 'list', 'position': 0, 'description': 'List of statistics records grouped by time frame ', 'items': {'type': 'dict', 'properties': {'records': {'type': 'list', 'items': {'type': 'dict', 'properties': {'keyID': {'type': 'int'}, 'value': {'type': 'dict', 'additionalProperties': {'type': 'int'}}}}}, 'timeFrame': {'type': 'dict', 'properties': {'startTime': {'type': 'int'}, 'endTime': {'type': 'int'}}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}
search_host_assets = {'tags': ['assets/v1'], 'summary': 'Returns a set of HostAssets defined by a HostAssetSearchCriteria. (PUBLIC)', 'description': '', 'operationId': 'searchHostAssets', 'consumes': ['application/json'], 'produces': ['application/json', 'text/csv'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'name': {'type': 'list', 'description': 'Restrict search to specific asset name', 'uniqueItems': True, 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (start timestamp).'}, 'endTimestamp': {'type': 'int', 'description': 'Restrict search to a time frame based on the set TimeFieldStrategy (end timestamp).'}, 'keywords': {'type': 'list', 'description': 'Search for keywords.', 'uniqueItems': True, 'items': {'type': 'string'}}, 'keywordMatchStrategy': {'type': 'str', 'description': 'Defines the MatchStrategy for keywords (default match all keywords).', 'enum': ['all', 'any']}, 'timeMatchStrategy': {'type': 'str', 'description': 'Defines how strict to match against different timestamps (all/any) using start and end timestamp (default any)', 'enum': ['all', 'any']}, 'hostID': {'type': 'list', 'description': 'Restrict search to specific host UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'serviceID': {'type': 'list', 'description': 'Restrict search to specific service UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'businessProcessID': {'type': 'list', 'description': 'Restrict search to specific business process UUIDs.', 'uniqueItems': True, 'items': {'type': 'str'}}, 'ipRange': {'type': 'str', 'example': '{"ipRange": ["10.0.5.1-10.0.5.30", "10.0.5.0/24", "10.0.5.1"]}', 'description': 'Restrict search to entities related to these IP-addresses (may specify single IPs, IP networks or IP ranges.'}, 'applicationPort': {'type': 'list', 'description': 'Restrict to applications listening on specific ports.', 'uniqueItems': True, 'items': {'type': 'int'}}, 'applicationProtocol': {'type': 'list', 'description': 'Restrict to applications by transport protocol name.', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}}, 'cpe': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications or hosts by CPE.'}, 'hostCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to hosts by CPE.'}, 'applicationCPE': {'type': 'str', 'example': 'cpe:2.3:o:microsoft:windows:2008:r2', 'description': 'Restrict to applications by CPE.'}, 'countTimeout': {'type': 'int', 'example': 0, 'description': 'Max wait in seconds for count query, if max wait passed and count query still executing the query; or -1 is set to indicate do not count, then the query will be cancelled and return count -1. Default value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'minimum': -1, 'maximum': 30}, 'limit': {'type': 'int', 'position': 0, 'description': 'Set this value to set max number of results. By default, no restriction on result set size. '}, 'offset': {'type': 'int', 'position': 0, 'description': 'Set this value to skip the first (offset) objects. By default, return result from first object. '}, 'includeDeleted': {'type': 'bool', 'position': 0, 'description': 'Set to true to include deleted objects. By default, exclude deleted objects. '}, 'subCriteria': {'type': 'list', 'position': 0, 'description': 'Set additional criterias which are applied using a logical OR. ', 'uniqueItems': True, 'items': []}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'ownerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific ownerIDs ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'criticality': {'type': 'list', 'position': 0, 'description': 'Restrict search to a range of criticality levels (add multiple CriticalitySearch objects to specify OR criteria). ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['dimension', 'severities'], 'properties': {'dimension': {'type': 'str', 'position': 0, 'description': 'Which criticality dimention to search for ', 'enum': ['CONFIDENTIALITY', 'AVAILABILITY', 'INTEGRITY']}, 'severities': {'type': 'list', 'position': 0, 'description': 'Which severities to filter for specified dimension ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'maxItems': 2147483647, 'minItems': 1}}}}, 'minimumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a minimum total CVSS score. '}, 'maximumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a maximum total CVSS score. '}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Restrict to applications with specific roles (list of role IDs). ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'type': 'str', 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp on host). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}}, 'includeVulnerabilityRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false). '}, 'includeVulnerabilityConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false). '}, 'includeVulnerabilitySolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false). '}, 'includeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'Include host vulnerabilities in result (default false). '}, 'includeApplications': {'type': 'bool', 'position': 0, 'description': 'Include host applications in result (default false). '}, 'includeServices': {'type': 'bool', 'position': 0, 'description': 'Include related services in result (default false). '}, 'connectedToService': {'type': 'bool', 'position': 0, 'description': 'If true, only return hosts connected to service(s). If false, return hosts not connected to any service. If not set, do not filter. '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['owner', 'customer', 'name', 'totalCvss', 'vulnerabilitiesCount', 'operatingSystemCPE', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'options': ['SERVER', 'CLIENT']}}}, 'exclude': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria object will be excluded. '}, 'required': {'type': 'bool', 'position': 0, 'description': 'Only relevant for subcriteria. If set to true, objects matching this subcriteria are required (AND-ed together with parent criteria). '}, 'customerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to data belonging to specified customers. ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'ownerID': {'type': 'list', 'position': 0, 'description': 'Restrict search to specific ownerIDs ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'criticality': {'type': 'list', 'position': 0, 'description': 'Restrict search to a range of criticality levels (add multiple CriticalitySearch objects to specify OR criteria). ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['dimension', 'severities'], 'properties': {'dimension': {'type': 'str', 'position': 0, 'description': 'Which criticality dimention to search for ', 'enum': ['CONFIDENTIALITY', 'AVAILABILITY', 'INTEGRITY']}, 'severities': {'type': 'list', 'position': 0, 'description': 'Which severities to filter for specified dimension ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'maxItems': 2147483647, 'minItems': 1}}}}, 'minimumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a minimum total CVSS score. '}, 'maximumTotalCvss': {'type': 'float', 'position': 0, 'description': 'Restrict search to a maximum total CVSS score. '}, 'vulnerabilityReference': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability reference. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'vulnerabilityID': {'type': 'list', 'position': 0, 'description': 'Restrict to vulnerabilities identified by vulnerability ID. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'applicationRole': {'type': 'list', 'position': 0, 'description': 'Restrict to applications with specific roles (list of role IDs). ', 'uniqueItems': True, 'items': {'type': 'int'}}, 'type': {'type': 'str', 'position': 0, 'description': 'Restrict search to a specific type of host (client or server). ', 'enum': ['SERVER', 'CLIENT']}, 'timeFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which timestamps will be included in the search (default lastUpdatedTimestamp on host). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp', 'all']}}, 'keywordFieldStrategy': {'type': 'list', 'position': 0, 'description': 'Defines which fields will be searched by keywords (default all supported fields). ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}}, 'includeVulnerabilityRawOutput': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability rawOutput in result (default false). '}, 'includeVulnerabilityConclusion': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability conclusion in result (default false). '}, 'includeVulnerabilitySolution': {'type': 'bool', 'position': 0, 'description': 'Include vulnerability solution in result (default false). '}, 'includeVulnerabilities': {'type': 'bool', 'position': 0, 'description': 'Include host vulnerabilities in result (default false). '}, 'includeApplications': {'type': 'bool', 'position': 0, 'description': 'Include host applications in result (default false). '}, 'includeServices': {'type': 'bool', 'position': 0, 'description': 'Include related services in result (default false). '}, 'connectedToService': {'type': 'bool', 'position': 0, 'description': 'If true, only return hosts connected to service(s). If false, return hosts not connected to any service. If not set, do not filter. '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'List of properties to sort by (prefix with "-" to sort descending). ', 'items': {'type': 'str', 'enum': ['owner', 'customer', 'name', 'totalCvss', 'vulnerabilitiesCount', 'operatingSystemCPE', 'createdTimestamp', 'lastUpdatedTimestamp', 'lastEventTimestamp', 'deletedTimestamp', 'firstSeenTimestamp', 'lastSeenTimestamp', 'lastScanTimestamp']}}, 'includeFlags': {'type': 'list', 'position': 0, 'description': 'Only include objects which have includeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'excludeFlags': {'type': 'list', 'position': 0, 'description': 'Exclude objects which have excludeFlags set. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
search_host_assets_simplified = {'tags': ['assets/v1'], 'summary': 'Returns as set of HostAssets defined by query parameters. (PUBLIC)', 'description': '', 'operationId': 'searchHostAssetsSimplified', 'produces': ['application/json', 'text/csv'], 'parameters': [{'name': 'offset', 'in': 'query', 'description': 'Skip a number of results', 'required': False, 'type': 'int', 'default': 0, 'minimum': 0}, {'name': 'limit', 'in': 'query', 'description': 'Maximum number of returned results', 'required': False, 'type': 'int', 'default': 25, 'minimum': 0}, {'name': 'keywords', 'in': 'query', 'description': 'Search by keywords', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'keywordMatch', 'in': 'query', 'description': 'Set match strategy for keyword search', 'required': False, 'type': 'str', 'default': 'all', 'enum': ['all', 'any']}, {'name': 'keywordField', 'in': 'query', 'description': 'Set field strategy for keyword search', 'required': False, 'type': 'list', 'items': {'type': 'str', 'default': 'all', 'enum': ['name', 'description', 'alias', 'cpe', 'vulnerabilityID', 'vulnerabilityName', 'vulnerabilityReference', 'allHostProperties', 'all']}, 'collectionFormat': 'multi'}, {'name': 'name', 'in': 'query', 'description': 'Search by name', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'hostID', 'in': 'query', 'description': 'Search by HostAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'serviceID', 'in': 'query', 'description': 'Search by ServiceAsset ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'businessProcessID', 'in': 'query', 'description': 'Search by BusinessProcess ID', 'required': False, 'type': 'list', 'items': {'type': 'str'}, 'collectionFormat': 'multi'}, {'name': 'customerID', 'in': 'query', 'description': 'Search by customer ID', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'ip', 'in': 'query', 'description': 'Search by IP range', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'port', 'in': 'query', 'description': 'Search by application port', 'required': False, 'type': 'list', 'items': {'type': 'int'}, 'collectionFormat': 'multi'}, {'name': 'protocol', 'in': 'query', 'description': 'Search by application protocol', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['icmp', 'ip', 'tcp', 'udp', 'esp', 'unknown']}, 'collectionFormat': 'multi'}, {'name': 'cpe', 'in': 'query', 'description': 'Search by CPE', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'vulnID', 'in': 'query', 'description': 'Search by vulnerability ID', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'vulnRef', 'in': 'query', 'description': 'Search by vulnerability reference', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'includeFlag', 'in': 'query', 'description': 'Include certain HostAssets in the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}, 'collectionFormat': 'multi'}, {'name': 'excludeFlag', 'in': 'query', 'description': 'Exclude certain HostAssets from the search result based on set flags', 'required': False, 'type': 'list', 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}, 'collectionFormat': 'multi'}, {'name': 'sortBy', 'in': 'query', 'description': 'Sort search result', 'required': False, 'type': 'list', 'items': {'type': 'string'}, 'collectionFormat': 'multi'}, {'name': 'countTimeout', 'in': 'query', 'description': 'Max wait in seconds for count query. Value 0 means execute as long as service allows, -1 means do not count, max value is 30 (seconds).', 'required': False, 'type': 'int', 'maximum': 30, 'minimum': -1}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'list', 'description': 'Contains an array of results', 'items': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation error'}}}
update_host_asset = {'tags': ['assets/v1'], 'summary': 'Updates an existing HostAsset. (PUBLIC)', 'description': '', 'operationId': 'updateHostAsset', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'name': 'id', 'in': 'path', 'description': 'HostAsset ID', 'required': True, 'type': 'str'}, {'in': 'body', 'name': 'body', 'description': 'HostAsset update request', 'required': False, 'schema': {'type': 'object', 'required': ['source'], 'properties': {'ownerID': {'type': 'int', 'position': 0, 'description': 'Change user who owns the asset. '}, 'name': {'type': 'str', 'position': 0, 'description': 'Change name of asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'description': {'type': 'str', 'position': 0, 'description': 'Change description of asset.  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*'}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'enum': ['UNKNOWN', 'LOW', 'MEDIUM', 'HIGH', 'CRITICAL', 'unknown', 'low', 'medium', 'high', 'critical']}}}, 'addProperties': {'type': 'dict', 'position': 0, 'description': 'Add custom properties (updates a property if key already exists).  => [\\s\\w\\{\\}\\$\\-\\(\\)\\.\\[\\]"\\\'_/\\\\,\\*\\+\\#:@!?;=]*', 'additionalProperties': {'type': 'string'}}, 'deleteProperties': {'type': 'list', 'position': 0, 'description': 'Delete custom properties by key. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'type': {'type': 'str', 'position': 0, 'description': 'Change type of host (client or server). ', 'enum': ['SERVER', 'CLIENT']}, 'source': {'type': 'str', 'position': 0, 'description': 'Source of the request. (default USER)', 'enum': ['USER', 'CVM']}, 'operatingSystemCPE': {'type': 'str', 'position': 0, 'description': 'Change CPE of host. '}, 'addIpAddresses': {'type': 'list', 'position': 0, 'description': 'Add IP address(es) to host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteIpAddresses': {'type': 'list', 'position': 0, 'description': 'Delete IP address(es) from host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'addAliases': {'type': 'list', 'position': 0, 'description': 'Add alias(es) (domain names) to host. ', 'uniqueItems': True, 'items': {'type': 'string'}}, 'deleteAliases': {'type': 'list', 'position': 0, 'description': 'Delete alias(es) from host. ', 'uniqueItems': True, 'items': {'type': 'string'}}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'int', 'description': 'Status code returned from API'}, 'limit': {'type': 'int', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'int', 'description': 'Number of skipped results'}, 'count': {'type': 'int', 'description': 'Number of available results on server'}, 'size': {'type': 'int', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'dict', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'list', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'dict', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': 'str', 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'int'}, 'options': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}}}, 'data': {'type': 'dict', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'str'}, 'operatingSystemCPE': {'type': 'str', 'readOnly': True}, 'ownedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'str', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'dict', 'properties': {'confidentiality': {'type': 'str', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'str', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'str', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'float', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'int', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'dict', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': 'str', 'firstSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'int', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'list', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'list', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'list', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'list', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'str', 'readOnly': True}, 'sockets': {'type': 'list', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'list', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'id': {'type': 'str'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'dict', 'required': ['name'], 'properties': {'id': {'type': 'str'}, 'name': {'type': 'str', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'float'}, 'createdTimestamp': {'type': 'int'}, 'createdByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'lastUpdatedTimestamp': {'type': 'int'}, 'lastUpdatedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'deletedTimestamp': {'type': 'int'}, 'deletedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'firstSeenTimestamp': {'type': 'int'}, 'lastSeenTimestamp': {'type': 'int'}, 'resolutionTimestamp': {'type': 'int'}, 'resolvedByUser': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'int'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'str', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'dict', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'dict', 'properties': {'id': {'type': 'int'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'str', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'str', 'readOnly': True}, 'flags': {'type': 'list', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'str', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}, 'options': ['SERVER', 'CLIENT']}}}}}, '220': {'description': 'No value to be updated', 'schema': {'required': ['data'], 'properties': {'responseCode': {'type': 'integer', 'format': 'int32', 'description': 'Status code returned from API'}, 'limit': {'type': 'integer', 'format': 'int64', 'description': 'Maximum number of returned results'}, 'offset': {'type': 'integer', 'format': 'int64', 'description': 'Number of skipped results'}, 'count': {'type': 'integer', 'format': 'int64', 'description': 'Number of available results on server'}, 'size': {'type': 'integer', 'format': 'int64', 'description': 'Actual number of returned results'}, 'metaData': {'type': 'object', 'description': 'Additional unstructured meta data associated with response'}, 'messages': {'type': 'array', 'description': 'Contains messages returned from the API, usually error messages', 'items': {'type': 'object', 'properties': {'message': {'type': 'string'}, 'messageTemplate': {'type': 'string'}, 'type': {'type': 'string', 'enum': ['FIELD_ERROR', 'ACTION_ERROR', 'WARNING', 'NOTIFICATION', 'INFO']}, 'field': {'type': 'string'}, 'parameter': {'type': 'object'}, 'timestamp': {'type': 'integer', 'format': 'int64'}}}}, 'data': {'type': 'object', 'required': ['createdByUser', 'createdTimestamp', 'criticality', 'customer', 'lastUpdatedByUser', 'lastUpdatedTimestamp', 'name', 'properties', 'totalCvss', 'type', 'vulnerabilitiesCount'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'operatingSystemCPE': {'type': 'string', 'readOnly': True}, 'ownedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset '}, 'description': {'type': 'string', 'position': 0, 'description': 'Asset description '}, 'criticality': {'type': 'object', 'properties': {'confidentiality': {'type': 'string', 'position': 0, 'description': 'The confidentiality criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'integrity': {'type': 'string', 'position': 0, 'description': 'The integrity criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}, 'availability': {'type': 'string', 'position': 0, 'description': 'The availability criticality level ', 'enum': ['unknown', 'low', 'medium', 'high', 'critical']}}}, 'totalCvss': {'type': 'number', 'format': 'double', 'position': 0, 'description': 'The total CVSS score for this asset '}, 'vulnerabilitiesCount': {'type': 'integer', 'format': 'int32', 'position': 0, 'description': 'The total number of active vulnerabilities for this asset '}, 'createdTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was created '}, 'createdByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was last updated '}, 'lastUpdatedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was deleted '}, 'deletedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'flags': {'type': 'array', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'string', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'HAS_HIGH_VULN', 'HAS_CRITICAL_VULN', 'MERGED']}}, 'properties': {'type': 'object', 'position': 0, 'description': 'Properties set for this asset ', 'additionalProperties': {'type': 'string'}}, 'type': {'type': 'string', 'position': 0, 'description': 'The type of this host asset ', 'enum': ['SERVER', 'CLIENT']}, 'firstSeenTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was first seen (in a scan) '}, 'lastSeenTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was last seen (in a scan) '}, 'lastScanTimestamp': {'type': 'integer', 'format': 'int64', 'position': 0, 'description': 'The timestamp when this asset was last scanned for '}, 'ipAddresses': {'type': 'array', 'position': 0, 'description': 'The IP addresses this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'object', 'properties': {'host': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'public': {'type': 'boolean'}, 'address': {'type': 'string', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'aliases': {'type': 'array', 'position': 0, 'description': 'Any (non-authorative) domainname aliases this asset is marked with ', 'uniqueItems': True, 'items': {'type': 'object', 'properties': {'fqdn': {'type': 'string'}}}}, 'services': {'type': 'array', 'position': 0, 'description': 'The services this host asset is bound to ', 'uniqueItems': True, 'items': {'type': 'object', 'required': ['name'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset '}}}}, 'applications': {'type': 'array', 'position': 0, 'description': 'The applications registered on this asset ', 'uniqueItems': True, 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'host': {'type': 'object', 'required': ['name'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'role': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'createdTimestamp': {'type': 'integer', 'format': 'int64'}, 'createdByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64'}, 'deletedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'firstSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'cpe': {'type': 'string', 'readOnly': True}, 'sockets': {'type': 'array', 'readOnly': True, 'uniqueItems': True, 'items': {'type': 'string'}}, 'flags': {'type': 'array', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'string', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM']}}}}}, 'vulnerabilities': {'type': 'array', 'position': 0, 'description': 'The vulnerabilities registered on this asset ', 'uniqueItems': True, 'items': {'type': 'object', 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'vulnerabilityID': {'type': 'string'}, 'host': {'type': 'object', 'required': ['name'], 'properties': {'id': {'type': 'string', 'format': 'uuid'}, 'name': {'type': 'string', 'position': 0, 'description': 'The authorative name of the asset '}}}, 'references': {'type': 'array', 'uniqueItems': True, 'items': {'type': 'string'}}, 'name': {'type': 'string'}, 'description': {'type': 'string'}, 'conclusion': {'type': 'string'}, 'solution': {'type': 'string'}, 'rawOutput': {'type': 'string'}, 'cvss': {'type': 'number', 'format': 'double'}, 'createdTimestamp': {'type': 'integer', 'format': 'int64'}, 'createdByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'lastUpdatedTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastUpdatedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'deletedTimestamp': {'type': 'integer', 'format': 'int64'}, 'deletedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'firstSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'lastSeenTimestamp': {'type': 'integer', 'format': 'int64'}, 'resolutionTimestamp': {'type': 'integer', 'format': 'int64'}, 'resolvedByUser': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}, 'userName': {'type': 'string'}, 'name': {'type': 'string'}, 'customerID': {'type': 'integer', 'format': 'int64'}}}, 'resolutionComment': {'type': 'string'}, 'resolution': {'type': 'string', 'enum': ['ACCEPTED', 'FALSE_POSITIVE', 'SERVICE_NOT_AVAILABLE', 'NO_LONGER_VULNERABLE', 'UNRESOLVED', 'TEMPORARILY_ACCEPTED']}, 'properties': {'type': 'object', 'additionalProperties': {'type': 'string'}}, 'customer': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'name': {'type': 'string'}, 'shortName': {'type': 'string'}, 'domain': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int32'}, 'name': {'type': 'string'}}}}}, 'severity': {'type': 'string', 'enum': ['info', 'low', 'medium', 'high', 'critical']}, 'socket': {'type': 'string', 'readOnly': True}, 'flags': {'type': 'array', 'position': 0, 'description': 'Flags assigned to the object. ', 'uniqueItems': True, 'items': {'type': 'string', 'enum': ['DELETED', 'CONTROLLED_VERSION', 'CREATED_BY_CVM', 'UPDATED_BY_CVM', 'DETECTED_BY_CVM', 'MISSING_FROM_CVM', 'DELETED_FROM_CVM', 'EXPLOIT_AVAILABLE']}}}}}}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '404': {'description': 'Object not found'}, '412': {'description': 'Validation error'}}}