"""Autogenerated API schema"""
from argus_api import session


find_ranges = {'tags': ['/geoip/v1'], 'summary': 'Lookup IPs (DEV)', 'description': '', 'operationId': 'findRanges', 'consumes': ['application/json'], 'produces': ['application/json'], 'parameters': [{'in': 'body', 'name': 'body', 'description': 'Search criteria', 'required': False, 'schema': {'type': 'object', 'properties': {'countryID': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'int'}}, 'regionID': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'int'}}, 'locationID': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'int'}}, 'rangeID': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'int'}}, 'startIPAddress': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'fromIP': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toIP': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}, 'addressFamily': {'type': 'str', 'enum': ['IPv4', 'IPv6']}, 'ipAddress': {'type': 'list', 'uniqueItems': True, 'items': {'type': 'dict', 'properties': {'host': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'bool', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'int'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'str', 'xml': {'attribute': True}, 'readOnly': True}}}}, 'limit': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Limit results '}, 'offset': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Offset results '}, 'includeDeleted': {'type': 'bool', 'xml': {'attribute': True}, 'position': 0, 'description': 'Also include deleted objects (where implemented) '}, 'includeFlags': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects with these flags set '}, 'excludeFlags': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Exclude objects with these flags set '}, 'sortBy': {'type': 'list', 'position': 0, 'description': 'Order results by these properties (prefix with - to sort descending) ', 'items': {'type': 'string'}}, 'startTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects from this timestamp '}, 'endTimestamp': {'type': 'int', 'xml': {'attribute': True}, 'position': 0, 'description': 'Search objects until this timestamp '}}}}], 'responses': {'200': {'description': 'successful operation', 'schema': {'type': 'object', 'additionalProperties': {'type': 'object', 'properties': {'id': {'type': 'integer', 'format': 'int64'}, 'range': {'type': 'object', 'properties': {'fromAddress': {'type': 'object', 'properties': {'host': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'string', 'xml': {'attribute': True}, 'readOnly': True}}}, 'toAddress': {'type': 'object', 'properties': {'host': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'ipv6': {'type': 'boolean', 'xml': {'attribute': True}, 'readOnly': True}, 'public': {'type': 'boolean'}, 'maskBits': {'type': 'integer', 'format': 'int32'}, 'multicast': {'type': 'boolean'}, 'address': {'type': 'string', 'xml': {'attribute': True}, 'readOnly': True}}}}}, 'locationID': {'type': 'integer', 'format': 'int64'}, 'lastModified': {'type': 'integer', 'format': 'int64'}, 'flags': {'type': 'integer', 'format': 'int64'}, 'latitude': {'type': 'number', 'format': 'double'}, 'longitude': {'type': 'number', 'format': 'double'}, 'deleted': {'type': 'boolean'}}}}}, '401': {'description': 'Authentication failed'}, '403': {'description': 'Access denied'}, '412': {'description': 'Validation failed'}}}